<?php
/*
+ ----------------------------------------------------------------------------+
|     e107 website system
|
|     Steve Dunstan 2001-2002
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     $Source: /home/cvsroot/rota_menu/admin_config.php,v $
|     $Revision: 1.3 $
|     $Date: 2012/10/27 15:55:00 $
|     $Author: shdcvs $
|
|
| To do:
|	1. Need better icons for 'top' and 'bottom'
|
| Preferences:
|	$pref['dr_inc_set'] - set of event categories for which duty rota is active
|	$pref['dr_page_title'] - Title of display page
|	$pref['dr_admin_class'] - Class which can manage duty rota
|	$pref['dr_inc_category'] - set to include category column in user display
|	$pref['dr_show_listing'] - set to allow non-admins to see list of available rotas
|	$pref['dr_default_rota'] - allows setting of a 'show complete rota'
+----------------------------------------------------------------------------+
*/
require_once("../../class2.php");
require_once(e_HANDLER."userclass_class.php");
if (!getperms("P")) {
	header("location:".e_BASE."index.php");
}
	
	
$lan_file = e_PLUGIN."rota_menu/languages/".e_LANGUAGE.".php";
include_once(file_exists($lan_file) ? $lan_file : e_PLUGIN."rota_menu/languages/English.php");

if (file_exists('../calendar_menu/ecal_class.php') && isset($pref['eventpost_admin']) && isset($pref['dr_admin_class']))
{
  require_once('../calendar_menu/ecal_class.php');
}
else
{
  echo DR_NOTINSTALLED."<br /><br /><br />";
  exit;
}

if (isset($_POST['updatesettings'])) 
{
  $pref['dr_inc_set'] = implode(",", $_POST['dr_cat_class']);
  $pref['dr_admin_class'] = $_POST['dutyrota_admin_class'];
  $pref['dr_page_title'] = $_POST['dutyrota_page_title'];
  $pref['dr_inc_category'] = $_POST['dr_inc_category'];
  $pref['dr_show_listing'] = $_POST['dr_show_listing'];
  $pref['dr_default_rota'] = $_POST['dutyrota_default_rota'];
  save_prefs();
  $message = DR_ADLAN_3; // "Duty rota settings updated.";
}


require_once(e_ADMIN."auth.php");

if (isset($message)) 
{
	$ns->tablerender("", "<div style='text-align:center'><b>$message</b></div>");
}

if (e_QUERY) 
{
	$dr_qs = explode(".", e_QUERY);
}

$dr_text = '';
$dr_message = '';

  require_once("rota_class.php");
  $rota_manage = new duty_rota;		// Should create database object $dr_sql
	
if(!defined("USER_WIDTH")) { define("USER_WIDTH","width:97%"); }

//====================================================================
//			GENERAL FUNCTIONS
//====================================================================

function show_categories($list_name, $list_value, $filter_set = '')
  {		// display all the current categories as checkboxes
    global $dutyrota2_db;
	$dr_inc_prefs = array();
    if (isset($list_value)) $dr_inc_prefs = array_flip(explode(",",$list_value));
	if (!is_object($dutyrota2_db)) $dutyrota2_db = new db;
	$cal_arg = "(event_cat_name != '".EC_DEFAULT_CATEGORY."') ";
	if ($filter_set) $cal_arg .= " AND find_in_set(event_cat_id,'{$filter_set}')";

	if ($dutyrota2_db->db_Select("event_cat", "event_cat_id,event_cat_name", $cal_arg." order by event_cat_name"))
	{
	  while ($row = $dutyrota2_db->db_Fetch())
	  {
	    $selected = isset($dr_inc_prefs[$row['event_cat_id']]);
		$text .= "<input type='checkbox' name='".$list_name."[]' value='".$row['event_cat_id'].($selected == 1?"' checked='checked'":"'")." />".$row['event_cat_name']."\n<br /> ";
	  } 
	}
	else
	{
	  $text .= DR_ADLAN_7;		// No categories, or error
	} 
	return $text;
  }

//====================================================================
//			FIELDS CONFIGURATION MENU
//====================================================================
if(isset($dr_qs[0]) && $dr_qs[0] == "fields")
{
  $dr_field_num = varset($dr_qs[1],-1);
  $dr_field_action = varset($dr_qs[2],'');		// newfield, editfield, deletefield
  
// Start by doing any update required
  if (isset($_POST['savefieldinfo']) && (($dr_field_action == 'newfield') || ($dr_field_action == 'updatefield')))
  {  // Write changes to database
    if ($_POST['fieldnum'] != $dr_field_num)
	{  // We have an inconsistency!
	  $dr_message = "****************** POSSIBLE PROBLEM ******************";
	}
    elseif (($_POST['fieldnum'] == -1) && ($dr_field_action != 'newfield'))
	{  // Another possible problem
	  $dr_message = "****************** INCONSISTENT ACTION ******************";
	}   // Has field ID - -1 for new field
	else
	{  // Can update database here
	  $dr_field_title = trim($tp->toDB($_POST['dr_field_title']));
	  $dr_field_width = $tp->toDB($_POST['dr_field_width']);
	  $dr_field_lines = $tp->toDB($_POST['dr_field_lines']);
	  $dr_field_textbox = $tp->toDB($_POST['dr_field_textbox']);
	  $dr_field_regex = $tp->toDB($_POST['dr_field_regex']);
	  $dr_field_desc  = $tp->toDB($_POST['dr_field_desc']);
	  
	  // Do some basic sanity checks on values first
	  if ($dr_field_title == '') $dr_message = DR_ADLAN_45;
	  if (($dr_field_width <= 2) || ($dr_field_width > 200)) $dr_message .= "<br />".DR_ADLAN_46;
	  if (($dr_field_lines < 1) || ($dr_field_lines > 10)) $dr_message .= "<br />".DR_ADLAN_47;
	  
	  if ($dr_message == '')
	  {  // Can add info - no errors found
	    if ($dr_field_action == 'updatefield')
	    {  // Update existing field
	      $dr_qry = "dr_field_title='{$dr_field_title}',dr_field_desc='{$dr_field_desc}',dr_field_regex='{$dr_field_regex}',dr_field_lines='".intval($dr_field_lines)."',dr_field_width='".intval($dr_field_width)."',dr_field_textbox='".intval($dr_field_textbox)."', dr_edited_by='".USERID."',dr_last_edit='".intval(time())."' WHERE dr_field_id = '".intval($dr_field_num)."' ";
          if ($rota_manage->dr_sql->db_Update("dr_field_defs", $dr_qry) === FALSE)
		  {
		    $dr_message = DR_ADLAN_43.$dr_field_title.", ".$dr_field_num;
		  }
		  else
		  {
	        $dr_message = DR_ADLAN_41.$dr_field_title;
		    $rota_manage->dr_log(2,$dr_field_title);		// Note in admin log
		  }
	    }
	    else
	    {  // Add new field
	      $dr_qry = "0,'{$dr_field_title}','{$dr_field_desc}','{$dr_field_regex}','".intval($dr_field_lines)."','".intval($dr_field_width)."','".intval($dr_field_textbox)."', '".USERID."','".intval(time())."' ";
          if ($rota_manage->dr_sql->db_Insert("dr_field_defs", $dr_qry) === FALSE)
		  {
		    $dr_message = DR_ADLAN_42.$dr_field_title.", ".$dr_field_num;
		  }
		  else
		  {
	        $dr_message = DR_ADLAN_40.$dr_field_title;
		    $rota_manage->dr_log(1,$dr_field_title);		// Note in admin log
		  }
	    }
	  }
	}
	$dr_field_action = '';
  }

  
// Read list of existing fields from database - needs to be after any updates are done
  $field_list = $rota_manage->ret_fields();

// Now display the edit/new field area if required
  $add_new = isset($_POST['addnewfield']) || (count($field_list) == 0);
  if ($add_new) $dr_field_action = 'newfield';
  


  if (($dr_field_action == 'editfield') || ($dr_field_action == 'deletefield') || ($dr_field_action == 'confirmdelete'))
  {  // Read in existing field definitions (they are already in the $field_list variable)
    foreach ($field_list as $sel_field)
	{
	  if ($sel_field['dr_field_id'] == $dr_field_num) break;
	}
	if ($sel_field['dr_field_id'] == $dr_field_num)
	{  
	  $dr_field_title = $sel_field['dr_field_title'];
	  $dr_field_width = $sel_field['dr_field_width'];
	  $dr_field_lines = $sel_field['dr_field_lines'];
	  $dr_field_textbox = $sel_field['dr_field_textbox'];
	  $dr_field_regex = $sel_field['dr_field_regex'];
	  $dr_field_desc  = $sel_field['dr_field_desc'];
	}
	else
	  $dr_message = DR_ADLAN_44.$dr_field_num;

	if ($dr_field_action == 'deletefield')
	{  // Put up confirmatory action screen
	  $dr_text .= "<br />
		<form id='drdeletefield' method='post' action='".e_SELF."?fields.".$dr_field_num.".confirmdelete'>
			<table class='fborder' style='".USER_WIDTH."'>
		<colgroup>
		<col style='width : 50%; vertical-align:top;' />
		<col style='width : 50%; vertical-align:top;' />
		</colgroup>
		<tr>
			<td colspan='2' class='fcaption'>".DR_ADLAN_48.$dr_field_title."</td>
		</tr>
		<tr><td style='text-align:center' class='fcaption'><input class='button' type='submit' name='but_conf_del' value='".DR_ADLAN_51."' /></td>
		<td style='text-align:center' class='fcaption'><input class='button' type='submit' name='canceldelete' value='".DR_ADLAN_CANCEL."' /></td></tr>
		</table></form><br /><br />";
	  $dr_field_action = 'confirmdelete';
	}
	if ($dr_field_action == 'editfield')
	{
      $dr_field_action = 'updatefield';
	}
  }

	
  if (isset($_POST['but_conf_del']) && ($dr_field_action == 'confirmdelete'))
  {  // Actually delete field
	$dr_qry = "dr_field_id='".intval($dr_field_num)."' ";
    if ($rota_manage->dr_sql->db_Delete("dr_field_defs", $dr_qry))
    {
      $dr_message = DR_ADLAN_49.$dr_field_title; //Event Deleted
	  $rota_manage->dr_log(3,'db_Delete',$dr_field_title, $dr_qry);
    }
    else
    {
      $dr_message = DR_ADLAN_50.$dr_field_title; //Unable to delete event for some mysterious reason
    }
	
	// Re-read list of existing fields from database to reflect change
    $field_list = $rota_manage->ret_fields();
  }


  if ($dr_message != '') $dr_text .= "<br />".$dr_message."<br /><br />";

  if (($dr_field_action == 'updatefield') || ($dr_field_action == 'newfield'))
  {
	$dr_text .= "
		<form id='dreditfield' method='post' action='".e_SELF."?fields.".$dr_field_num.".".$dr_field_action."'>
			<table class='fborder' style='".USER_WIDTH."'>
		<colgroup>
		<col style='width : 25%; vertical-align:top;' />
		<col style='width : 45%; vertical-align:top;' />
		<col style='width : 30%; vertical-align:top; class:smalltext' />
		</colgroup>
		<tr>
			<td colspan='3' class='fcaption'>".DR_ADLAN_29."<input type='hidden' name='fieldnum' value=".$dr_field_num."></td>
		</tr>";
	$dr_text .= 
		"<tr><td class='forumheader3'>".DR_ADLAN_30."</td>
		     <td class='forumheader3'>
			 <input class='tbox' type='text' name='dr_field_title' size='30' value='".varset($dr_field_title,"")."' maxlength='50' style='width:95%' />
			 </td>
			 <td class='forumheader3'>".DR_ADLAN_31."</td></tr>";
	$dr_text .= 
		"<tr><td class='forumheader3'>".DR_ADLAN_32."</td>
		     <td class='forumheader3'>
			 <input class='tbox' type='text' name='dr_field_width' size='5' value='".varset($dr_field_width,"")."' maxlength='10' />
			 </td>
			 <td class='forumheader3'>".DR_ADLAN_33."</td></tr>";
	$dr_text .= 
		"<tr><td class='forumheader3'>".DR_ADLAN_34."</td>
		     <td class='forumheader3'>
			 <input class='tbox' type='text' name='dr_field_lines' size='5' value='".varset($dr_field_lines,"")."' maxlength='10'  />&nbsp;
			 <input class='tbox' type='checkbox' name='dr_field_textbox' value='1' ".($dr_field_textbox==1?" checked='checked' ":"")." />".DR_ADLAN_94."
			 </td>
			 <td class='forumheader3'>".DR_ADLAN_35."</td></tr>";
	$dr_text .= 
		"<tr><td class='forumheader3'>".DR_ADLAN_36."</td>
		     <td class='forumheader3'>
			 <input class='tbox' type='text' name='dr_field_regex' size='50' value='".varset($dr_field_regex,"")."' maxlength='100' style='width:95%' />
			 </td>
			 <td class='forumheader3'>".DR_ADLAN_37."</td></tr>";
	$dr_text .= 
		"<tr><td class='forumheader3'>".DR_ADLAN_38."</td>
		     <td class='forumheader3'>
			 <textarea class='tbox' name='dr_field_desc' cols='59' rows='8' style='width:95%'>".varset($dr_field_desc,"")."</textarea>
			 <td class='forumheader3'>".DR_ADLAN_39."</td></tr>";
	
	$dr_text .= "<tr><td colspan='3'  style='text-align:center' class='fcaption'><input class='button' type='submit' name='savefieldinfo' value='".DR_ADLAN_28."' /></td></tr>";
	$dr_text .= "</table></form>";
	$dr_text .= '<br /><br />';
  }


// Now display current field list
	$dr_delete_icon = e_IMAGE."admin_images/delete_16.png";
	$dr_edit_icon = e_IMAGE."admin_images/edit_16.png";
	$dr_text .= "
		<form id='drfieldsupdate' method='post' action='".e_SELF."?fields'>
			<table class='fborder' style='".USER_WIDTH."'>
		<colgroup>
		<col style='width :  8%; vertical-align:top;' />
		<col style='width : 16%; vertical-align:top;' />
		<col style='width : 45%; vertical-align:top;' />
		<col style='width :  8%; vertical-align:top;' />
		<col style='width :  8%; vertical-align:top;' />
		<col style='width : 15%; vertical-align:top;' />
		</colgroup>
		<tr>
			<td colspan='6' class='fcaption'>".DR_ADLAN_15."</td>
		</tr>";
		
	if (count($field_list) == 0)
	{
	  $dr_text .= "
			<tr>
				<td colspan='6' class='forumheader3'><strong>".DR_ADLAN_16."</strong></td>
			</tr>";
	}
	else
	{  // ID, Title, Description, Length, Lines, Action
	  $dr_text .= "
			<tr>
			  <td class='forumheader3'><strong>".DR_ADLAN_17."</strong></td>
			  <td class='forumheader3'><strong>".DR_ADLAN_18."</strong></td>
			  <td class='forumheader3'><strong>".DR_ADLAN_19."</strong></td>
			  <td class='forumheader3'><strong>".DR_ADLAN_20."</strong></td>
			  <td class='forumheader3'><strong>".DR_ADLAN_21."</strong></td>
			  <td class='forumheader3'><strong>".DR_ADLAN_22."</strong></td>
			</tr>";
	  foreach ($field_list as $this_field)
	  {
	    $dr_text .= "
		  <tr>
			<td class='forumheader3'>".$this_field['dr_field_id']."</td>
			<td class='forumheader3'>".$this_field['dr_field_title']."</td>
			<td class='forumheader3'>".$this_field['dr_field_desc']."</td>
			<td class='forumheader3'>".$this_field['dr_field_width']."</td>
			<td class='forumheader3'>".$this_field['dr_field_lines'].($this_field['dr_field_textbox'] ? '*' : '')."</td>
			<td class='forumheader3'>"."<a href='".e_SELF."?fields.{$this_field['dr_field_id']}.editfield'><img src='{$dr_edit_icon}' alt='".DR_ADLAN_EDIT."' title='".DR_ADLAN_EDIT."'/></a>".
			                           "<a href='".e_SELF."?fields.{$this_field['dr_field_id']}.deletefield'><img src='{$dr_delete_icon}' alt='".DR_ADLAN_DELETE."' title='".DR_ADLAN_DELETE."'/></a>"."</td>
		  </tr>";
	  }
	}
	$dr_text .= "<tr><td colspan='6'  style='text-align:center' class='fcaption'><input class='button' type='submit' name='addnewfield' value='".DR_ADLAN_27."' /></td></tr>";
	$dr_text .= "</table></form>";
	$ns->tablerender(DR_ADLAN_24,$dr_text);

}
//====================================================================
//			LISTS (VIEWS) CONFIGURATION MENU
//====================================================================
if(isset($dr_qs[0]) && $dr_qs[0] == "views")
{
// Read list of existing field definitions from database 
  $dr_field_list = $rota_manage->ret_fields();

// Possible actions:
//	chooseview - select new view, edit existing view, delete existing view
//	newview
//	editview
//	delview
//	addfield - adds field ID to current view

  $dr_view_action = varset($dr_qs[1],'chooseview');
  $dr_view_shortcode = varset($dr_qs[2],'');
  $dr_view_subaction = varset($dr_qs[3],'');
  $dr_view_title = '';
  if (($dr_view_action != 'chooseview') && !$dr_view_shortcode)
  {
    echo "Null shortcode unexpectedly<br /><br />";
	$dr_view_action = 'chooseview';
  }

  $dr_save_list_flag = FALSE;

// Preset database values
  $dr_list_code = '';
  $dr_list_title = '';
  $dr_list_comment = '';
  $dr_list_categories = '';
  $dr_list_edit_class = e_UC_ADMIN;
  $dr_list_view_class = e_UC_MEMBER;
  $dr_list_contact = '';
  $dr_list_email = '';
  $dr_list_fields = '';

  if (isset($_POST['addnewview']))
  {
    $dr_view_action = 'newview';
  }

// Read in data for current list if appropriate
  if (($dr_view_shortcode) && ($dr_view_action=='addfield') 
							|| ($dr_view_action=='saveview') 
							|| ($dr_view_action=='savefields') 
							|| ($dr_view_action=='editview') 
							|| ($dr_view_action=='delfieldconf') 
							|| ($dr_view_action=='reorder'))
  {
	if ($rota_manage->dr_sql->db_Select('dr_list_defs','*',"dr_list_code='{$dr_view_shortcode}'"))
	{
	  if ($dr_row=$rota_manage->dr_sql->db_Fetch())
	  {
		extract($dr_row);		// dr_list_code, dr_list_title, dr_list_comment, dr_list_categories, dr_list_edit_class, 
								// dr_list_view_class, dr_list_contact, dr_list_email, dr_list_fields
	    $dr_fields_used = explode(',',$dr_list_fields);		// Comma separated list of field IDs
	    $dr_fields_used = array_unique($dr_fields_used);		// Filter any glitches
	  }
	}
  }
  
// Start by doing any updates required
  switch ($dr_view_action)
  {
    case 'delviewconf':
	//  DELETE COMPLETE LIST RECORD
	  if ($_POST['confdelview'])
	  {
	    if (!$rota_manage->dr_sql->db_Delete('dr_list_defs',"'dr_list_code'='{$dr_view_shortcode}'"))
	    {
	      $dr_message = DR_ADLAN_87;
	    }
	    else
	    {
	      $dr_message = DR_ADLAN_58;
	    }
	  }
	  $dr_view_action = 'chooseview';
	  break;
	case 'delfieldconf':
	  // Delete a single field **********************
	  if (($_POST['confdelfield']) && is_numeric($dr_view_subaction))
	  {
	    $dr_view_element = $dr_view_subaction;
	    echo "Going to remove field: ".$dr_field_list[$dr_view_element]['dr_field_title']." from list<br />";
	    $dr_array_index = array_search($dr_view_element,$dr_fields_used);
		unset($dr_fields_used[$dr_array_index]);
	    $dr_list_fields = implode(',',$dr_fields_used);
		if (substr($dr_list_fields,0,1) == ',') $dr_list_fields = substr($dr_list_fields,1,-1);
//	    $dr_save_list_flag = TRUE;
	    $dr_message = DR_ADLAN_59." - not implemented yet";
	  }
	  $dr_view_action = 'editview';
	  break;
	case 'newview' :		// Just created a new list
	  $dr_view_title = trim($tp->toDB($_POST['dr_view_title']));
	  $dr_view_shortcode = trim($tp->toDB($_POST['dr_view_shortcode']));
	  if (!($dr_view_title) || !($dr_view_shortcode))
	  {
	    $dr_message = DR_ADLAN_64;		// Empty field
		$dr_view_action = 'chooseview';
	  }
	  else
	  {  // save values
	    $dr_list_code = $dr_view_shortcode;
		$dr_list_title = $dr_view_title;
	    $dr_save_list_flag = TRUE;
	    $dr_message = DR_ADLAN_60." - not implemented yet";
	    $dr_view_action = 'editview';
	  }
	  break;
	case 'saveview' :		// Save the 'header' for a view
	  if (isset($_POST['savelistmain']))
	  {
	    $dr_list_title = trim($tp->toDB($_POST['dr_list_title']));
		$dr_view_title = $dr_list_title;
		$dr_view_shortcode = $dr_list_code;
	    $dr_list_comment = trim($tp->toDB($_POST['dr_list_comment'])); 
	    $dr_list_contact = trim($tp->toDB($_POST['dr_list_contact']));
	    $dr_list_email   = trim($tp->toDB($_POST['dr_list_email']));
	    $dr_list_categories = implode(',',$_POST['dr_eventcatclass']);
	    $dr_list_edit_class = intval($_POST['dr_list_edit_class']);
	    $dr_list_view_class = intval($_POST['dr_list_view_class']);
	    $dr_save_list_flag = TRUE;
	    $dr_message = DR_ADLAN_60;
	    $dr_view_action = 'editview';
	  }
	  break;
	case 'savefields' :		// Save updated field info for a view
	  $dr_save_list_flag = TRUE;
	  $dr_list_fields = implode(',',$_POST['dr_view_order']);
	  $dr_message = DR_ADLAN_61." - possibly not implemented yet";
	  $dr_view_action = 'editview';
	  break;
	case 'addfield' :		// Save field info from drop-down box
	  if (is_numeric($_POST['dr_new_field_select']) && isset($dr_field_list[$_POST['dr_new_field_select']]) && isset($_POST['addnewfield']))
	  {  //  Add field to list
	    if ($dr_list_fields) $dr_list_fields .= ',';
		$dr_list_fields .= $_POST['dr_new_field_select'];
		$dr_save_list_flag = TRUE;
	    $dr_message = DR_ADLAN_62;
	  }
	  else
	  {
	    $dr_message = DR_ADLAN_85;
	  }
	  $dr_view_action = 'editview';
	  break;
	case 'reorder' :		// Save new field order - 'up', 'down', 'top', 'bottom', 'delete'
	  list($dr_view_subaction,$dr_view_element) = explode('^',$dr_view_subaction);					// Action, field ID number
	  if (!is_numeric($dr_view_element)) exit;		// Pick up fiddling
	  $dr_array_index = array_search($dr_view_element,$dr_fields_used);
	  if ($dr_array_index === FALSE) exit;
//	  echo "Subaction: ".$dr_view_subaction."  Element: ".$dr_view_element."  Index: ".$dr_array_index."<br />";
	  $dr_view_action = 'editview';		// Next state for all but delete
	  // Here, $dr_array_index has the position of field with id = $dr_view_element
	  switch ($dr_view_subaction)
	  {
	    case 'top' :
		  for ($i = $dr_array_index; $i > 0; $i--) $dr_fields_used[$i] = $dr_fields_used[$i-1];
		  $dr_fields_used[0] = $dr_view_element;
		  break;
		case 'up' :
		  if ($dr_array_index != 0)
		  {
		    $temp = $dr_fields_used[$dr_array_index-1];
			$dr_fields_used[$dr_array_index-1] = $dr_fields_used[$dr_array_index];
			$dr_fields_used[$dr_array_index] = $temp;
		  }
		  break;
		case 'down' :
		    $temp = $dr_fields_used[$dr_array_index+1];
			$dr_fields_used[$dr_array_index+1] = $dr_fields_used[$dr_array_index];
			$dr_fields_used[$dr_array_index] = $temp;
		  break;
		case 'bottom' :
		  for ($i = $dr_array_index; $i < count($dr_fields_used) - 1; $i++) $dr_fields_used[$i] = $dr_fields_used[$i+1];
		  $dr_fields_used[count($dr_fields_used) - 1] = $dr_view_element;
		  break;
		case 'delete' :
	      $dr_view_action = 'delfield';
		  break;
		default :
		  echo "Invalid action<br />";
	  }
	  if ($dr_view_action == 'editview')
	  {
	    $dr_list_fields = implode(',',$dr_fields_used);
		if (substr($dr_list_fields,0,1) == ',') $dr_list_fields = substr($dr_list_fields,1,-1);
	    $dr_save_list_flag = TRUE;
	    $dr_message = DR_ADLAN_63;
	  }
	  break;
  }
  
  if ($dr_save_list_flag)
  {  // Save current values after update (also handles a new record)
    if ($rota_manage->dr_sql->db_Select_gen("REPLACE INTO #dr_list_defs 
	         (dr_list_code, dr_list_title, dr_list_comment, dr_list_categories, dr_list_edit_class, dr_list_view_class, dr_list_contact, dr_list_email, dr_list_fields) 
	         VALUES ('{$dr_list_code}', 
			         '".$tp->toDB($dr_list_title)."', 
					 '".$tp->toDB($dr_list_comment)."', '{$dr_list_categories}', '{$dr_list_edit_class}', '{$dr_list_view_class}', 
					 '".$tp->toDB($dr_list_contact)."', '".$tp->toDB($dr_list_email)."', '{$dr_list_fields}')") === FALSE)
	{
	  $dr_message .= "<br />".DR_ADLAN_86;		// Error saving values
	}
    $dr_fields_used = explode(',',$dr_list_fields);		// Comma separated list of field IDs
  }
 
  if ($dr_message != '') $dr_text .= "<br /><span style='text-align:center; font-weight:bold'>".$dr_message."</span><br /><br />";
 
// Updates complete - do the display bit
  switch ($dr_view_action)
  {
    case 'delview' :		// Delete a complete view - confirm
	  $dr_text .= "
		<form id='drviewdelconf' method='post' action='".e_SELF."?views.delviewconf.{$dr_view_shortcode}'>
			<table class='fborder' style='".USER_WIDTH."'>
			<tr><td colspan='2' style='text-align:center' class='forumheader3'>".DR_ADLAN_90.$dr_view_shortcode."</td></tr>
			<tr><td style='text-align:center' class='forumheader3'><input class='button' type='submit' name='confdelview' value='".DR_ADLAN_51."' /></td>
			    <td style='text-align:center' class='forumheader3'><input class='button' type='submit' name='canceldelview' value='".DR_ADLAN_CANCEL."' /></td></tr>
			</table></form>";
	  $ns->tablerender(DR_ADLAN_25,$dr_text);
	  $dr_view_action = 'delviewconf';
	  break;
	  
	case 'delfield' :			// Delete a field - confirm
	  $dr_text .= "
		<form id='drviewdelconf' method='post' action='".e_SELF."?views.delfieldconf.{$dr_view_shortcode}.{$dr_view_element}'>
			<table class='fborder' style='".USER_WIDTH."'>
			<tr><td colspan='2' style='text-align:center' class='forumheader3'>".DR_ADLAN_91.$dr_field_list[$dr_view_element]['dr_field_title']."</td></tr>
			<tr><td style='text-align:center' class='forumheader3'><input class='button' type='submit' name='confdelfield' value='".DR_ADLAN_51."' /></td>
			    <td style='text-align:center' class='forumheader3'><input class='button' type='submit' name='canceldelfield' value='".DR_ADLAN_CANCEL."' /></td></tr>
			</table></form>";
	  $ns->tablerender(DR_ADLAN_25,$dr_text);
	  $dr_view_action = 'delfieldconf';
	  break;
	  
    case 'editview' :
/*	  // Start by reading in existing data
	  if (!$rota_manage->dr_sql->db_Select('dr_list_defs','*',"dr_list_code='{$dr_view_shortcode}'"))
	  {
	    $dr_message = DR_ADLAN_66.$dr_view_shortcode;
	  }
	  else
	  {
	    if ($dr_row=$rota_manage->dr_sql->db_Fetch())
		{
		  extract($dr_row);		// dr_list_code, dr_list_title, dr_list_comment, dr_list_categories, dr_list_edit_class, 
								// dr_list_view_class, dr_list_contact, dr_list_email, dr_list_fields
		}
	  }    Data should already be read in
	 */
	  // Start by displaying the 'header' info
	  $dr_text .= "
		<form id='drviewsave' method='post' action='".e_SELF."?views.saveview.{$dr_view_shortcode}'>
			<table class='fborder' style='".USER_WIDTH."'>
		<colgroup>
		<col style='width : 20%; vertical-align:top;' />
		<col style='width : 40%; vertical-align:top;' />
		<col style='width : 40%; vertical-align:top;' />
		</colgroup>
		<tr><td class='forumheader3'>".DR_ADLAN_55."</td><td class='forumheader3'>{$dr_list_code}</td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_83."</span></td></tr>
		<tr><td class='forumheader3'>".DR_ADLAN_56."</td><td class='forumheader3'><input class='tbox' type='text' name='dr_list_title' value='{$dr_list_title}' size='50' maxlength='60' /></td>
				  <td class='forumheader3'><span class='smalltext'>".DR_ADLAN_68."</span></td></tr>		 
		<tr><td class='forumheader3'>".DR_ADLAN_69."</td><td class='forumheader3'>
		          <textarea class='tbox' name='dr_list_comment' cols='40' rows='4' style='width:95%'>".$dr_list_comment."</textarea>
				  </td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_70."</span></td></tr>
		<tr><td class='forumheader3'>".DR_ADLAN_71."</td><td class='forumheader3'>";
		
// Now display all the current categories as checkboxes
	    $dr_text .= show_categories('dr_eventcatclass', $dr_list_categories, $pref['dr_inc_set']);

	    $dr_text .= "</td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_72."</span></td></tr>
			<tr><td class='forumheader3'>".DR_ADLAN_73."</td><td class='forumheader3'>".r_userclass("dr_list_edit_class", $dr_list_edit_class, "off",  'public, nobody, member, admin, classes')."</td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_74."</span></td></tr>
			<tr><td class='forumheader3'>".DR_ADLAN_75."</td><td class='forumheader3'>".r_userclass("dr_list_view_class", $dr_list_view_class, "off",  'public, nobody, member, admin, classes')."</td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_76."</span></td></tr>
			<tr><td class='forumheader3'>".DR_ADLAN_77."</td><td class='forumheader3'><input class='tbox' type='text' name='dr_list_contact' value='{$dr_list_contact}' size='40' maxlength='40' /></td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_78."</span></td></tr>
			<tr><td class='forumheader3'>".DR_ADLAN_79."</td><td class='forumheader3'><input class='tbox' type='text' name='dr_list_email' value='{$dr_list_email}' size='40' maxlength='60' /></td><td class='forumheader3'><span class='smalltext'>".DR_ADLAN_80."</span></td></tr>
			<tr><td colspan='3' class='fcaption' style='text-align:center'><input class='button' type='submit' name='savelistmain' value='".DR_ADLAN_89."' /></td></tr>
			</table></form>";
		
	// Now display the list of fields in a separate form
	// Note that the field list array sets the display order			
		$dr_action_icons = array( 
	        'top' 	=> "images/top_16.png",
			'up'	=> "images/up_16.png",
			'down'	=> "images/down_16.png",
			'bottom' => "images/bottom_16.png",
			'delete' => e_IMAGE."admin_images/delete_16.png" );
			
	    $dr_text .= "
		    <form id='drfieldsave' method='post' action='".e_SELF."?views.addfield.{$dr_view_shortcode}'>
			<table class='fborder' style='".USER_WIDTH."'>
		<colgroup>
		<col style='width : 20%; vertical-align:top;' />
		<col style='width : 40%; vertical-align:top;' />
		<col style='width : 40%; vertical-align:top;' />
		</colgroup>
			<tr>
				<td colspan='3' class='fcaption'><strong>".DR_ADLAN_81."</strong></td>
			</tr>";

//	  $dr_fields_used = explode(',',$dr_list_fields);		// Comma separated list of field IDs
//	  $dr_fields_used = array_unique($dr_fields_used);		// Filter any glitches
	  if (count( $dr_fields_used) == 0)
	  {
	    $dr_text .= "
			<tr>
				<td colspan='3' class='forumheader3' style='text-align:center'><strong>".DR_ADLAN_82."</strong></td>
			</tr>";
	  }
	  else
	  {  
	    foreach ($dr_fields_used AS $dr_field_element)
		{  // Name, Title, Action
		// ****************** LOOK UP THE FIELD INFO BASED ON THE ID **********************
		// ****************** LAST COLUMN IS ACTIONS - TOP, UP, DOWN, BOTTOM, DELETE ************************
	      $dr_text .= "
			<tr>
			  <td class='forumheader3'><input type='hidden' name='dr_view_order[]' value='{$dr_field_element}' />".$dr_field_list[$dr_field_element]['dr_field_title']."</td>
			  <td class='forumheader3'>".$dr_field_list[$dr_field_element]['dr_field_desc']."</td>
			  <td class='forumheader3'>";
		  foreach($dr_action_icons AS $dr_action => $dr_image)
		  {
		    $dr_text .= "<a href='".e_SELF."?views.reorder.{$dr_list_code}.{$dr_action}^{$dr_field_list[$dr_field_element]['dr_field_id']}' title='{$dr_action}'> <img src='{$dr_image}' alt='' /> </a>";
		  }
		  $dr_text .= "</td>
			</tr>";
		  $dr_field_list[$dr_field_element]['field_used'] = TRUE;
		}
	  }
		// Now show drop-down list of unused fields which could be added, with a button to 'Add'
	  $dr_text .= "<tr><td class='forumheader3' colspan='2'><select name='dr_new_field_select'><option value='none'>".DR_ADLAN_84."</option>";
	  foreach ($dr_field_list as $dr_field_element)
	  {
	    if (!$dr_field_element['field_used']) $dr_text .= "<option value='{$dr_field_element['dr_field_id']}'>{$dr_field_element['dr_field_title']}</option>";
	  }
	  $dr_text .= "</select></td><td class='forumheader3'><input class='button' type='submit' name='addnewfield' value='".DR_ADLAN_27."' /></td></tr>";
	
	  $dr_text .= "</table></form>";
	  $ns->tablerender(DR_ADLAN_25,$dr_text);
	  break;
//----------------------------	
	case 'chooseview' :		// Display list of lists
	  $dr_text .= "
		<form id='drviewslist' method='post' action='".e_SELF."?views'>
			<table class='fborder' style='".USER_WIDTH."'>
		<colgroup>
		<col style='width : 15%; vertical-align:top;' />
		<col style='width : 30%; vertical-align:top;' />
		<col style='width : 35%; vertical-align:top;' />
		<col style='width : 20%; vertical-align:top;' />
		</colgroup>
		<tr><td colspan='4' class='fcaption'>".DR_ADLAN_52."</td></tr>";

		// Shortcode  |  title  |  field list  |  actions
	  if ($rota_manage->dr_sql->db_Select('dr_list_defs','*'))
	  {  // Show existing lists
	    $dr_text .= "<tr><td style='text-align:center' class='fcaption'>".DR_ADLAN_55."</td>
		                 <td style='text-align:center' class='fcaption'>".DR_ADLAN_56."</td>
						 <td style='text-align:center' class='fcaption'>".DR_ADLAN_57."</td>
						 <td style='text-align:center' class='fcaption'>".DR_ADLAN_22."</td></tr>";

	    while ($dr_row = $rota_manage->dr_sql->db_Fetch())
		{
		  $dr_text .= "<tr><td class='forumheader3'>{$dr_row['dr_list_code']}</td><td class='forumheader3'>{$dr_row['dr_list_title']}</td>
					   <td class='forumheader3'>";
		  foreach (explode(',',$dr_row['dr_list_fields']) as $dr_this_field)
		  {
		    $dr_text .= $dr_field_list[$dr_this_field]['dr_field_title'].'; ';
		  }
		  $dr_text .= "</td><td class='forumheader3'>
		          <a href='".e_SELF."?views.editview.{$dr_row['dr_list_code']}'><img src='".e_IMAGE."admin_images/edit_16.png' alt=''/></a>
		          <a href='".e_SELF."?views.delview.{$dr_row['dr_list_code']}'><img src='".e_IMAGE."admin_images/delete_16.png' alt=''/></a>
				  </td></tr>";
		}
	  }
	  else
	  {
	    $dr_text .= "<tr><td colspan='4'  style='text-align:center' class='forumheader3'>".DR_ADLAN_54."</td></tr>";
	  }
	  $dr_text .= "<tr><td class='forumheader3'><input class='tbox' type='text' name='dr_view_shortcode' size='10' value='{$dr_view_shortcode}' maxlength='10' /></td>
			<td class='forumheader3'><input class='tbox' type='text' name='dr_view_title' value='{$dr_view_title}' size='50' maxlength='60' /></td>
			<td class='fcaption'><input class='button' type='submit' name='addnewview' value='".DR_ADLAN_53."' /></td>
			<td class='forumheader3'><span class='smalltext'>".DR_ADLAN_67."</span></td></tr>";
	  $dr_text .= "</table></form>";
	  $ns->tablerender(DR_ADLAN_25,$dr_text);
	break;
	
	default :
	  $dr_text = "Unrecognised option: ".$dr_view_action."<br /><br />";
	  $ns->tablerender(DR_ADLAN_25,$dr_text);
	  break;
  }  // END Switch
}

/*
//====================================================================
//			DATES CONFIGURATION MENU (not implemented)
//====================================================================

if((isset($dr_qs[0]) && $dr_qs[0] == "dates"))
{

	$text = "<div style='text-align:center'>
	<form method='post' action='".e_SELF."?dates'>
	<table style='width:97%' class='fborder'>
	<tr><td style='vertical-align:top;' colspan='2' class='fcaption'>".EC_ADLAN_A100." </td></tr>
	<tr>
		<td style='width:40%;vertical-align:top;' class='forumheader3'>".EC_ADLAN_A108."</td>
		<td style='width:60%;vertical-align:top;' class='forumheader3'><input class='tbox' type='text' name='eventpost_fe_menuheading' size='35' value='".$pref['eventpost_menuheading']."' maxlength='30' />
		</td>
	</tr>

	<tr>
		<td style='width:40%;vertical-align:top;' class='forumheader3'>".EC_ADLAN_A101."</td>
		<td style='width:60%;vertical-align:top;' class='forumheader3'><input class='tbox' type='text' name='eventpost_fe_daysforward' size='20' value='".$pref['eventpost_daysforward']."' maxlength='10' />
		</td>
	</tr>

	<tr>
		<td style='width:40%;vertical-align:top;' class='forumheader3'>".EC_ADLAN_A102."</td>
		<td style='width:60%;vertical-align:top;' class='forumheader3'><input class='tbox' type='text' name='eventpost_fe_numevents' size='20' value='".$pref['eventpost_numevents']."' maxlength='10' />
		</td>
	</tr>

	<tr>
		<td style='width:40%;vertical-align:top;' class='forumheader3'>".EC_ADLAN_A103."<br /><span class='smalltext'><em>".EC_ADLAN_A107."</em></span></td>
		<td style='width:60%;vertical-align:top;' class='forumheader3'><input class='tbox' type='checkbox' name='eventpost_fe_checkrecur' value='1' ".($pref['eventpost_checkrecur']==1?" checked='checked' ":"")." /></td>
	</tr>
	
	<tr>
		<td style='width:40%;vertical-align:top;' class='forumheader3'>".EC_ADLAN_A104."</td>
		<td style='width:60%;vertical-align:top;' class='forumheader3'><input class='tbox' type='checkbox' name='eventpost_fe_linkheader' value='1' ".($pref['eventpost_linkheader']==1?" checked='checked' ":"")." />
		</td>
	</tr>
	
	
	<tr><td colspan='2'  style='text-align:center' class='fcaption'><input class='button' type='submit' name='setdates' value='".EC_LAN_77."' /></td></tr>
	</table>
	</form>
	</div>";
	
	$ns->tablerender("<div style='text-align:center'>".EC_ADLAN_A100."</div>", $text);
}   // End of Rota Periods configuration
*/



//====================================================================
//			MAIN CONFIGURATION MENU
//====================================================================

// This section should be complete

if(!isset($dr_qs[0]) || (isset($dr_qs[0]) && $dr_qs[0] == "config"))
{
	$text = "<div style='text-align:center'>
	<form method='post' action='".e_SELF."'>
	<table style='width:97%' class='fborder'>	
	<colgroup>
	<col style='width : 40%; vertical-align:top;' />
	<col style='width : 60%; vertical-align:top;' />
	</colgroup>
	<tr><td style='vertical-align:top;' colspan='2' class='fcaption'>".DR_ADLAN_9." </td></tr>
	<tr>
		<td class='forumheader3'>".DR_ADLAN_10."<br /><span class='smalltext'><em>".DR_ADLAN_11."</em></span> </td>
		<td class='forumheader3'>". r_userclass("dutyrota_admin_class", $pref['dr_admin_class'], "off", 'admin, classes')."
		</td>
	</tr>
	<tr>
		<td class='forumheader3'>".DR_ADLAN_12."</td>
		<td class='forumheader3'><input class='tbox' type='text' name='dutyrota_page_title' size='50' value='".$pref['dr_page_title']."' maxlength='100' />
		</td>
	</tr>
	<tr>
		<td class='forumheader3'>".DR_ADLAN_8."</td>
		<td class='forumheader3'>";

    $text .= show_categories('dr_cat_class',$pref['dr_inc_set']);
  
	$text .= "</td>
	</tr>
	<tr>
		<td class='forumheader3'>".DR_ADLAN_92."</td>
		<td class='forumheader3'>
			<input class='tbox' type='checkbox' name='dr_inc_category' value='1' ".($pref['dr_inc_category']==1?" checked='checked' ":"")." /></td>
	</tr>
	<tr>
		<td class='forumheader3'>".DR_ADLAN_93."</td>
		<td class='forumheader3'>
			<input class='tbox' type='checkbox' name='dr_show_listing' value='1' ".($pref['dr_show_listing']==1?" checked='checked' ":"")." /></td>
	</tr>
	<tr>
		<td class='forumheader3'>".DR_ADLAN_95."<br /><span class='smalltext'><em>".DR_ADLAN_96."</em></span> </td>
		<td class='forumheader3'><input class='tbox' type='text' name='dutyrota_default_rota' size='50' value='".$pref['dr_default_rota']."' maxlength='100' />
		</td>
	</tr>

	<tr><td colspan='2'  style='text-align:center' class='fcaption'><input class='button' type='submit' name='updatesettings' value='".DR_ADLAN_14."' /></td></tr>
	</table>
	</form>
	</div>";
	
	$ns->tablerender("<div style='text-align:center'>".DR_ADLAN_13."</div>", $text);
}

//====================================================================
//			PAGE MENU SETUP
//====================================================================

function admin_config_adminmenu()
{
		if (e_QUERY) {
			$tmp = explode(".", e_QUERY);
			$action = $tmp[0];
		}
		if ($action == "") {
			$action = "config";
		}
		$var['config']['text'] = DR_ADLAN_4;
		$var['config']['link'] = "admin_config.php";
			
		$var['fields']['text'] = DR_ADLAN_5;
		$var['fields']['link'] ="admin_config.php?fields";
		
		$var['views']['text'] = DR_ADLAN_26;
		$var['views']['link'] ="admin_config.php?views";
		
//		$var['dates']['text'] = DR_ADLAN_6;
//		$var['dates']['link'] ="admin_config.php?dates";		// For the future!

		show_admin_menu(DR_ADLAN_23, $action, $var);
}


require_once(e_ADMIN."footer.php");

?>