<?php
/*
+ ----------------------------------------------------------------------------+
|     e107 website system
|
|     Steve Dunstan 2001-2002
|     http://e107.org
|     jalist@e107.org
|
|     Released under the terms and conditions of the
|     GNU General Public License (http://gnu.org).
|
|     $Source: /home/cvsroot/rota_menu/rota.php,v $
|     $Revision: 1.2 $
|     $Date: 2012/01/15 10:17:40 $
|     $Author: shdcvs $
|
|
| Preferences:
|	$pref['dr_inc_set'] - set of event categories for which duty rota is active
|	$pref['dr_page_title'] - Title of display page
|	$pref['dr_admin_class'] - Class which can manage duty rota
|	$pref['dr_inc_category'] - set to include category column in user display
|	$pref['dr_show_listing'] - set to allow non-admins to see list of available rotas
|	$pref['dr_default_rota'] - allows setting of a 'show complete rota'
+----------------------------------------------------------------------------+
*/

/*
File displays the duty rota.
With no parameter, possibly displays a list of rotas (or the only rota, if only one)
Parameters:     listcode.end_date.start_date[.edit_event || 'pdf' || 'print']
Date format is: yyyymmdd (as for event calendar list printing)
*/

require_once('../../class2.php');

//$lan_file = e_PLUGIN.'rota_menu/languages/'.e_LANGUAGE.'.php';
//include_once(file_exists($lan_file) ? $lan_file : e_PLUGIN.'rota_menu/languages/English.php');
include_lan(e_PLUGIN.'rota_menu/languages/'.e_LANGUAGE.'.php');

if (!isset($pref['plug_installed']['rota_menu']) || !isset($pref['plug_installed']['calendar_menu']) || !isset($pref['eventpost_admin']) || !isset($pref['dr_admin_class']))
{
	echo DR_NOTINSTALLED."<br /><br /><br />";
}

require_once("rota_class.php");
$rota_manage = new duty_rota;		// Should create database object $dr_sql

require_once('../calendar_menu/ecal_class.php');
if (!isset($ecal_class) || !is_object($ecal_class)) $ecal_class = new ecal_class;

$is_rota_admin = check_class(e_UC_MAINADMIN) || check_class($pref['eventpost_admin']) || check_class($pref['dr_admin_class']);
/*
if (is_readable(THEME."dutyrota_template.php")) 
{
  require(THEME."dutyrota_template.php");
}
else 
{
  require(e_PLUGIN."rota_menu/dutyrota_template.php");
}
*/

$dr_qs = explode('.',e_QUERY);

$dr_list_name = $tp->toDB(varset($dr_qs[0],''));
$dr_list_end = intval(varset($dr_qs[1],0));
$dr_list_start = intval(varset($dr_qs[2],0));
$dr_list_edit = varset($dr_qs[3],0);

if ($dr_list_start == 0)  $dr_list_start = strftime("%Y%m%d",time()); //  echo $dr_list_start."=start<br />"; }
if ($dr_list_end == 0)  $dr_list_end = strftime("%Y%m%d",time() + 86400*365); // echo $dr_list_end."=end<br />"; }

$dr_list_output = 'display';

if (($dr_list_edit === 'pdf') || ($dr_list_edit === 'print'))
{
	$dr_list_output = $dr_list_edit;
}

if (isset($_POST['dr_print_form']))
{
	$dr_list_output = 'print';
}

if (!is_numeric($dr_list_edit)) $dr_list_edit = 0;

$dr_pdf_options = '';


if ($dr_list_output == 'display') require_once(HEADERF);


$dr_message = '';

// ***************** Look up start and end dates
if (!is_numeric($dr_start_date = decode_date($dr_list_start,FALSE)))
{
	$dr_message = $dr_start_date;
}
elseif (!is_numeric($dr_end_date = decode_date($dr_list_end,TRUE)))
{
	$dr_message = $dr_end_date;
}
elseif ($dr_start_date >= $dr_end_date)
{
	$message = DR_LAN_15;
}
elseif (($dr_end_date - $dr_start_date) > 365*86400)
{
	$message = DR_LAN_16;
}


//===============================================
//			HANDLE UPDATES
//===============================================
if (isset($_POST['edit_dr_save']) && $is_rota_admin)
{
	if ($_POST['dr_list_edit'] !== $dr_list_edit)
	{
		echo "Inconsistent information";
		exit;
	}

// Data to save:
  // $dr_list_edit is the related event ID
  // dr_field_col[] = rota field numbers

	if (0)
	{  // Print debug info
		echo "Save information<br /><br /><table>";
		foreach ($_POST as $key => $val)
		{
			if (is_array($val))
			{
			  foreach ($val as $key2 => $val2)
			  {
				if (is_array($val2))
				{
				  foreach($val2 as $key3 => $val3)
				  {
				echo "<tr><td>{$key}[{$key2}][{$key3}]</td><td>{$val3}</td></tr>";
				  }
				}
				else
				{
				echo "<tr><td>{$key}[{$key2}]</td><td>{$val2}</td></tr>";
				}
			  }
			}
			else
			{
			  echo "<tr><td>{$key}</td><td>{$val}</td></tr>";
			}
		}
		echo "</table><br /><br />";
	}


	$dr_message = DR_LAN_13;
	$dr_field_col = $_POST['dr_field_col'];
	foreach ($_POST['dr_list_textbox'] as $dr_key => $dr_is_textbox)
	{
		if ($dr_is_textbox)
		{  // Field is a text box - we can use it 'as is'
			$dr_name_block = $tp->toDB($_POST['dr_field_desc'][$dr_key]);
			//	  echo "field {$dr_key} value {$dr_name_block} is textarea<br />";
		}
		else
		{  // Need to implode multi-line fields
			$dr_name_block = $tp->toDB(implode("\n",$_POST['dr_field_col'][$dr_key]));
			//	  echo "field {$dr_key} value {$dr_name_block} is multiline <br />";
		}
		$dr_query = "REPLACE INTO #dr_event_entry (dr_event_id, dr_field_num, dr_names, dr_edited_by, dr_last_edit) 
								VALUES ('{$dr_list_edit}', '{$dr_key}', '{$dr_name_block}', '".USERID."', ".time().") ";

		if (($dr_db_error = $rota_manage->dr_sql->db_Select_gen($dr_query)) === FALSE)
		{
			$dr_message = "Error saving information: ".$dr_db_error;
			break;
		}
	}
	$dr_list_edit = 0;		// This hides the edit screen
}

if ($dr_message != '')
{
	$ns->tablerender(DR_LAN_10,$dr_message);
	$dr_message = '';
	//  require_once(FOOTERF);
	//  exit;
}




$dr_text = '';		// Display text

// Look up the list definition first, make sure we can view it, and maybe edit it
// If no list name, potentially get and display all of them
$dr_query = '';
if (!$is_rota_admin) $dr_query = "find_in_set(dr_list_view_class,'".USERCLASS_LIST."') ";
if ($dr_list_name)
{
	if ($dr_query) $dr_query .= ' AND ';
	$dr_query .= "dr_list_code='{$dr_list_name}' ";
}
else
{
	if (!$is_rota_admin && !$pref['dr_show_listing'])
	{
		$ns->tablerender(DR_LAN_10,DR_LAN_04);
		require_once(FOOTERF);
		exit;
	}
}


if ($dr_query) $dr_query = ' WHERE '.$dr_query;
$dr_query = "SELECT * FROM #dr_list_defs ".$dr_query;
if ($dr_list_count = $rota_manage->dr_sql->db_Select_gen($dr_query))
{
	if ($dr_list_count > 1)
	{  // Show list to select from
		$dr_text .= "<table class='fborder' style='".USER_WIDTH."'>
			<colgroup>
			<col style='width : 20%; vertical-align:top;' />
			<col style='width : 40%; vertical-align:top;' />
			<col style='width : 40%; vertical-align:top;' />
			</colgroup>";
		  $dr_text .= "<tr><td class='forumcaption'>".DR_ADLAN_55."</td><td class='forumcaption'>".DR_ADLAN_56."</td><td class='forumcaption'>".DR_LAN_01."</td></tr>";
		
		while ($dr_row=$rota_manage->dr_sql->db_Fetch())
		{  // Show list of lists, with clickable links
		  extract($dr_row);
		  $dr_click_link = "<a href='".e_SELF."?{$dr_list_code}' title='".DR_LAN_02."'>";
		  $dr_text .= "<tr><td class='forumheader3'>{$dr_click_link}{$dr_list_code}</a></td><td class='forumheader3'>{$dr_click_link}{$dr_list_title}</a></td><td class='forumheader3'>{$dr_list_comment}</td></tr>";
		}
		$dr_text .= "</table>";
	}
	else
	{  // Get the single list and display it
		if ($dr_row=$rota_manage->dr_sql->db_Fetch())
		{
		  extract($dr_row);
		  $dr_list_name = $dr_list_code;
		}
		else
		{  // Error
		  $dr_text .= DR_LAN_03;
		}
	}
}
else
{  // No list available/accessible
	$dr_text .= DR_LAN_04;
}

if ($dr_text)
{  // Error or selection list
	$ns->tablerender(DR_LAN_10,$dr_text);
	require_once(FOOTERF);
	exit;
}



function show_column_defs($display_list)
{
	$ret = '<colgroup>';
	foreach ($display_list as $dr_field)
	{
		$ret .= "<col style='width : {$dr_field['cols']}%; vertical-align:top;' />";
	}
	$ret .= '</colgroup>';
	return $ret;
}


function show_table_titles($display_list)
{  
	$ret = '<tr>';
	foreach ($display_list as $dr_field)
	{
		$ret .= "<td class='forumheader3'>{$dr_field['title']}</td>";
	}
	$ret .= '</tr>';
  return $ret;
}


// Return a time/date string
function rota_time_date($rota_date, $allday = FALSE)
{ // (Previous format string: "%d-%b-%y %H:%M" )
	global $ecal_class;
	if ($allday) return $ecal_class->event_date_string($rota_date);
	return $ecal_class->event_date_string($rota_date)." ".$ecal_class->time_string($rota_date);
}




// Got a list to display now
$is_rota_admin = $is_rota_admin || check_class($dr_list_edit_class);

/*
			  WHERE dld.dr_list_code = {$dr_list_name} 
#dr_list_defs as dld 
	dr_list_code varchar(10) NOT NULL default '',
	dr_list_title varchar(60) NOT NULL default '',
	dr_list_comment text NOT NULL,
	dr_list_categories varchar(255) NOT NULL default '',
	dr_list_edit_class int(10) unsigned not NULL default 254,
	dr_list_view_class int(10) unsigned NOT NULL default 253,
	dr_list_contact varchar(60) NOT NULL default '',
	dr_list_email varchar(60) NOT NULL default '',
	dr_list_fields varchar(255) NOT NULL default '',
*/

// Get the complete list of fields
$dr_field_list = $rota_manage->ret_fields();

// For the list, work out the total width required in characters, and apportion columns appropriately.
$dr_display_list = array();
$dr_display_list[] = array('field' => 'dr_event_start_date', 'is_db'=> FALSE, 'can_edit' => FALSE, 'width' => 20, 'lines' => 1, 'is_textbox' => '0', 'title' => DR_LAN_07, 'addclick' => TRUE);
$dr_display_list[] = array('field' => 'event_title', 'is_db'=> TRUE, 'can_edit' => FALSE,  'width' => 30, 'lines' => 1, 'is_textbox' => '0', 'title' => DR_LAN_08, 'addclick' => TRUE);
if ($pref['dr_inc_category']) 
{
	$dr_display_list[] = array('field' => 'event_cat_name', 'is_db'=> TRUE, 'can_edit' => FALSE, 'width' => 20, 'lines' => 1, 'is_textbox' => '0', 'title' => DR_LAN_09, 'addclick' => FALSE);
}
$dr_total_width = 70;						// Width in characters of preceding 3 fields
$dr_list_temp = explode(',',$dr_list_fields);
foreach ($dr_list_temp as $dr_field)
{
	$dr_display_list[] = array(	'field' => $dr_field, 'is_db'=> TRUE, 'can_edit' => TRUE,
								'width' => $dr_field_list[$dr_field]['dr_field_width'], 
								'lines' => $dr_field_list[$dr_field]['dr_field_lines'], 
								'is_textbox' => varset($dr_field_list[$dr_field]['dr_field_textbox'], '0'), 
								'title' => $dr_field_list[$dr_field]['dr_field_title'],
								'addclick' => FALSE
								);
	$dr_total_width += $dr_field_list[$dr_field]['dr_field_width'];
}

// Now assign widths as percentages. Use floor() to make sure sum is <= 100%
foreach ($dr_display_list as $dr_field)
{
	$dr_field['cols'] = floor(100*$dr_field['width']/$dr_total_width);
}


//=====================================
//				EDIT AREA
//=====================================
// In edit mode, display the edit form here above the list of events. Will also need to read current info (if any) for the event
if ($dr_list_edit)
{ // $dr_list_edit is the event ID number

// ********** Read in event info
	$dr_query = "SELECT e.event_id, e.event_start, e.event_title, e.event_category, e.event_allday, dr.*,
						ec.event_cat_id, ec.event_cat_name
				FROM #event as e
				LEFT JOIN #dr_event_entry as dr ON e.event_id = dr.dr_event_id
				LEFT JOIN #event_cat as ec ON e.event_category = ec.event_cat_id
				WHERE e.event_id='{$dr_list_edit}'";
	if ($rota_manage->dr_sql->db_Select_gen($dr_query))
	{  // Display events
		$dr_row=$rota_manage->dr_sql->db_Fetch();
	}
	else
	{
		echo 'Error reading event';
		require_once(FOOTERF);
		exit;
	}
    $dr_qry2 = "SELECT * FROM #dr_event_entry WHERE dr_event_id={$dr_row['event_id']} AND find_in_set(dr_field_num, '{$dr_list_fields}')";
	if ($sql2->db_Select_gen($dr_qry2))
	{
		while ($dr_name_row = $sql2->db_Fetch())
		{  // Get the values associated with each column of names
			$dr_row['fields'][$dr_name_row['dr_field_num']] = $dr_name_row['dr_names'];
		}
	}

	$dr_event_start_date = rota_time_date($dr_row['event_start'], $dr_row['event_allday']);
	// Save the event ID as a hidden field
	$dr_text .= "
		<form id='drrotaedit' method='post' action='".e_SELF.'?'.e_QUERY."'>
		  <input type='hidden' name='dr_list_edit' value='{$dr_list_edit}' />
			<table class='fborder' style='".USER_WIDTH."'>".show_column_defs($dr_display_list).show_table_titles($dr_display_list)."<tr>";
			
// Now display the field values/edit boxes
	foreach ($dr_display_list as $dr_field)
	{
		$dr_rownum = 0;
		if ($dr_field['is_db'])
		{
			if (is_numeric($dr_field['field']))
			{  // Its a configurable duty rota field
			  $dr_temp = varset($dr_row['fields'][$dr_field['field']],'');
			}
			else
			{
			  $dr_temp = varset($dr_row[$dr_field['field']],'');
			}
		}
		else
		{
			$dr_temp = ${$dr_field['field']};
		}
		
		$dr_line = $dr_temp;
		$dr_text .= "<td class='forumheader3'>";
		// For editable fields, include a hidden field to say whether current field is a text box or an array of individual boxes
		if ($dr_field['can_edit'])
		{
			$dr_text .= "<input type='hidden' name='dr_list_textbox[{$dr_field['field']}]' value='{$dr_field['is_textbox']}' />";
		}
		if ($dr_field['is_textbox'])
		{
			$dr_text.=" <textarea class='tbox' name='dr_field_desc[{$dr_field['field']}]' cols='{$dr_field['width']}' rows='{$dr_field['lines']}' style='width:95%'>".$dr_line."</textarea>";
		}
		else
		{
			if ($dr_field['lines'] > 1) $dr_temp = explode("\n",$dr_temp);
			if (!is_array($dr_temp)) $dr_temp = array($dr_temp);
			for ($i = 0; $i < $dr_field['lines']; $i++)
			{
			  if ($i) $dr_text .= "<br />";
			  if ($dr_field['can_edit'])
			  {
				$dr_text .= "<input class='tbox' type='text' name='dr_field_col[{$dr_field['field']}][{$i}]' size='{$dr_field['width']}' value='".$dr_temp[$i]."' maxlength='{$dr_field['width']}' style='width:95%' />";
			  }
			  else
			  {
				$dr_text .= $dr_line;
			  }
			}
		}
		$dr_text .= "</td>";
	}
	// Finally, a submit button
	$dr_text .= "</tr><tr><td colspan='".count($dr_display_list)."' style='text-align:center' class=forumheader3><input class='button' type='submit' name='edit_dr_save' value='".DR_ADLAN_28."' /></td></tr></table></form>";
	$dr_text .= "<br /><br />";		//.... and a spacer to separate from the main list
}


//=====================================
//				DISPLAY AREA
//=====================================
// Now get the events. They must be visible to current user class.
	$dr_query = "SELECT e.event_id, e.event_start, e.event_title, e.event_category, e.event_allday,
					 ec.event_cat_id, ec.event_cat_name
	          FROM #event as e
			  LEFT JOIN #event_cat as ec ON e.event_category = ec.event_cat_id
			  WHERE e.event_start >= {$dr_start_date} AND e.event_start < {$dr_end_date} AND e.event_recurring = '0' 
			    AND find_in_set(e.event_category,'".$pref['dr_inc_set']."')
				AND find_in_set(e.event_category,'".$dr_list_categories."') {$ecal_class->extra_query}
			  ORDER BY e.event_start ASC";

  

if ($dr_event_count = $rota_manage->dr_sql->db_Select_gen($dr_query))
{  // Display events

  $dr_text .= "
		<form id='drrotashow' method='post' action='".e_SELF."?{$dr_list_code}.{$dr_list_end}.{$dr_list_start}.{$dr_list_output}'>
			<table class='fborder' style='".USER_WIDTH."'>".show_column_defs($dr_display_list);

// Now display the list title and any comment (not title - its on form)
//  $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumcaption' style='text-align:center'>{$dr_list_title}</td></tr>";
  if (trim($dr_list_comment) !== '')
  {
    $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumheader3' style='text-align:center'>{$dr_list_comment}</td></tr>";
  }

// Display contact details
  if ($dr_list_contact)
  {
    if ($dr_list_email)
	{
	  if (strpos($dr_list_email,'@') !== FALSE)
	  {  // Use generic email code
	    $dr_list_contact = "[link=mailto:{$dr_list_email}]{$dr_list_contact}[/link]";
	  }
	  else
	  {  // 'Organisation' email
	    $dr_list_contact = "[smail={$dr_list_email}]{$dr_list_contact}[/smail]";
	  }
	}
	$dr_list_contact = $tp->toHTML($dr_list_contact,TRUE,"no_make_clickable");
    $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumheader3' style='text-align:center'>".DR_LAN_12.$dr_list_contact."</td></tr>";
  }


  $dr_text .= show_table_titles($dr_display_list);
 
  while ($dr_row=$rota_manage->dr_sql->db_Fetch())
  {
    // e.event_id - hidden field used for edit link
	// e.event_start - format into $event_start_date
	// e.event_title
	// ec.event_cat_name
	// Rota fields as set
    $dr_qry2 = "SELECT * FROM #dr_event_entry WHERE dr_event_id={$dr_row['event_id']} AND find_in_set(dr_field_num, '{$dr_list_fields}')";
	if ($sql2->db_Select_gen($dr_qry2))
	{
	  while ($dr_name_row = $sql2->db_Fetch())
	  {  // Get the values associated with each column of names
	    $dr_row['fields'][$dr_name_row['dr_field_num']] = $dr_name_row['dr_names'];
	  }
	}

	$dr_clicklink = "<a href='".e_SELF."?{$dr_list_name}.{$dr_list_end}.{$dr_list_start}.{$dr_row['event_id']}' title='".DR_LAN_06."'>";
	$dr_event_start_date = rota_time_date($dr_row['event_start'], $dr_row['event_allday']);
	
	$dr_text .= '<tr>';
	
	foreach ($dr_display_list as $dr_field)
	{
	  if ($dr_field['is_db'])
	  {
	    if (is_numeric($dr_field['field']))
		{  // Its a configurable duty rota field
		  $dr_temp = varset($dr_row['fields'][$dr_field['field']],'');
		}
		else
		{
	      $dr_temp = varset($dr_row[$dr_field['field']],'');
		}
	  }
	  else
	  {
	    $dr_temp = ${$dr_field['field']};
	  }
	  if ($dr_field['lines'] > 1) $dr_temp = str_replace("\n","<br />",$dr_temp);		// This should just work for textareas as well
	  if ($is_rota_admin && $dr_field['addclick'] && ($dr_list_output == 'display'))
	  {
	    $dr_text .= "<td class='forumheader3'>".$dr_clicklink.$dr_temp."</a></td>";
	  }
	  else
	  {
	    $dr_text .= "<td class='forumheader3'>".$dr_temp."</td>";
	  }
	}
	$dr_text .= "</tr>";
  }
  
  if ($dr_list_output == 'print')
  {
    $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumheader3' style='text-align:center'><input type='button' value='".DR_LAN_19."' onClick='window.print()' /></td></tr>";
  }
  else
  {
    $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumheader3' style='text-align:center'><input class='button' type='submit' name='dr_print_form' value='".DR_LAN_18."' /></td></tr>";
	if ((($dr_end_date - $dr_start_date) < 174000) && ($pref['dr_default_rota']) && strpos($pref['dr_default_rota'],$dr_list_name) === 0)
	{
    $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumheader3' style='text-align:center'>
	<a href='".e_SELF."?".$pref['dr_default_rota']."' title='".DR_LAN_22."'><input class='button' type='button' value='".DR_LAN_21."' /></a></td></tr>";
	}
  }
  if (($is_rota_admin) && ($dr_list_output == 'display')) $dr_text .= "<tr><td colspan='".count($dr_display_list)."' class='forumheader3' style='text-align:center'>".DR_LAN_11."</td></tr>";
  $dr_text .= "</table></form>";
}
else
{
  $dr_text .= DR_LAN_05;
}


switch ($dr_list_output)
{
  case 'display':
   $ns->tablerender($dr_list_title,$dr_text);
   require_once(FOOTERF);
   break;
  case 'print' :
    echo $dr_text;
	break;
  case 'pdf' :
	$lan_file = e_PLUGIN."pdf/languages/".e_LANGUAGE.".php";
	include_once(file_exists($lan_file) ? $lan_file : e_PLUGIN."pdf/languages/English.php");
	define('FPDF_FONTPATH', 'font/');
	require_once(e_PLUGIN."pdf/ufpdf.php");		//require the ufpdf class
	require_once(e_PLUGIN."pdf/e107pdf.php");	//require the e107pdf class
	if ($dr_pdf_options == "")
	  $pdf = new e107PDF();
	else
	  $pdf = new e107PDF($dr_pdf_options);
//	$text = array($text, $creator, $author, $title, $subject, $keywords, $url);
	$text = array($dr_text,'', '', DR_LAN_17,'','',e_SELF.e_QUERY);
	$pdf->makePDF($text);
	break;
}



function decode_date($date_string,$last_day = FALSE)
{  // Decode a date string
  if (strpos($date_string,'now') === 0)
  {  // decode special dates
    $today = getdate();
    $date_string = trim(substr($date_string,3));   // Knock off the 'now'
	if (($date_string != '') && ($date_string[0] == '+'))
	{
	  $date_string = trim(substr($date_string,1));	// Knock off the '+'
	  if (is_numeric($date_string) && ($date_string >= 0) && ($date_string <= 12))
	  {
	    $today['mon'] += $date_string;
		if ($today['mon'] > 12)
		{
		  $today['mon'] -= 12;
		  $today['year'] += 1;
		}
	  }
	  else
	  {
	    return DR_LAN_14;
	  }
	}
	$date_string = $today['year'].$today['mon'];
  }
  if (ctype_digit($date_string))
  {
    $month = 0;
	$day = 1;
	if (strlen($date_string) == 5) $date_string = substr_replace($date_string,'0',-1,0);
    if (strlen($date_string) == 8)
    {
      $day = substr($date_string,-2,2);
	  if ($last_day) $day += 1;
    }
    elseif (strlen($date_string) == 6)
    {
	  if ($last_day) $month = 1;
    }
    else
    {      // Error
	  return DR_LAN_14;
    }
	$month += substr($date_string,4,2);
	$year  = substr($date_string,0,4);
	$temp  = mktime(0,0,0,$month,$day,$year);
	if ($last_day) $temp -= 1;			// Always do this to get whole of last day
	return $temp;
  }
  else
  {    // Error
    return DR_LAN_14;
  }
}


?>
